#
# (C) COPYRIGHT 2002-2008 FLEXIBILIS OY, ALL RIGHTS RESERVED
#

set_source_file "afec.vhd"
set_module "afec"
set_module_description "AFEC Avalon"
set_module_property "author" "Flexibilis Oy"
set_module_property "className" "afec"
set_module_property "displayName" "AFEC"
set_module_property "group" "Interface Protocols/Ethernet"
set_module_property "instantiateInSystemModule" "true"
set_module_property "libraries" [ list "ieee.std_logic_1164.all" "ieee.numeric_std.all" "std.standard.all" ]
set_module_property "synthesisFiles" [ list "afec.vhd" ]

# Module parameters
add_parameter "RST_ACTIVE" "integer" "1" "Reset polarity"
set_parameter_property "RST_ACTIVE" "enabled" "true"
add_parameter "FIFO_ADDR_MSB" "integer" "10" "FIFO size, allowed range is from 6 to 10: 6=128B ... 10=2kB"
add_parameter "DESC_MSB" "integer" "2" "Number of descripors, allowed range is 2: 2=8 descriptors ..."
add_parameter "DEVICE_FAMILY" "string" "" "Target FPGA device family, fe. \"Stratix II GX\""
add_parameter "MEM_INIT_FILE" "string" "" "Memory initialization file, fe. \"./mem_init.hex\""

# Interface clock
add_interface "clock" "clock" "sink" "asynchronous"
# Ports in interface clock
add_port_to_interface "clock" "clk" "clk"
add_port_to_interface "clock" "rst" "reset"

# Interface export_0
add_interface "export_0" "conduit" "start" "clock"
# Ports in interface export_0
add_port_to_interface "export_0" "gtx_clk_sel" "export"
add_port_to_interface "export_0" "rx_rst" "export"
add_port_to_interface "export_0" "rx_clk" "export"
add_port_to_interface "export_0" "rx_dv" "export"
add_port_to_interface "export_0" "rxd" "export"
add_port_to_interface "export_0" "rx_er" "export"
add_port_to_interface "export_0" "tx_rst" "export"
add_port_to_interface "export_0" "tx_clk" "export"
add_port_to_interface "export_0" "txd" "export"
add_port_to_interface "export_0" "tx_en" "export"
add_port_to_interface "export_0" "tx_er" "export"
add_port_to_interface "export_0" "crs" "export"
add_port_to_interface "export_0" "col" "export"
add_port_to_interface "export_0" "tx_alignment" "export"
add_port_to_interface "export_0" "rx_time_req" "export"
add_port_to_interface "export_0" "rx_time_ack" "export"
add_port_to_interface "export_0" "rx_time_word" "export"
add_port_to_interface "export_0" "tx_time_req" "export"
add_port_to_interface "export_0" "tx_time_ack" "export"
add_port_to_interface "export_0" "tx_time_word" "export"
add_port_to_interface "export_0" "mdc" "export"
add_port_to_interface "export_0" "mdio_ena" "export"
add_port_to_interface "export_0" "mdio_out" "export"
add_port_to_interface "export_0" "mdio_in" "export"

# Interface mmur
add_interface "mmur" "avalon" "slave" "clock"
set_interface_property "mmur" "isNonVolatileStorage" "false"
set_interface_property "mmur" "burstOnBurstBoundariesOnly" "false"
set_interface_property "mmur" "readLatency" "0"
set_interface_property "mmur" "holdTime" "0"
set_interface_property "mmur" "printableDevice" "false"
set_interface_property "mmur" "readWaitTime" "1"
set_interface_property "mmur" "setupTime" "0"
set_interface_property "mmur" "addressAlignment" "DYNAMIC"
set_interface_property "mmur" "writeWaitTime" "0"
set_interface_property "mmur" "timingUnits" "Cycles"
set_interface_property "mmur" "minimumUninterruptedRunLength" "1"
set_interface_property "mmur" "isMemoryDevice" "false"
set_interface_property "mmur" "linewrapBursts" "false"
set_interface_property "mmur" "maximumPendingReadTransactions" "0"
# Ports in interface mmur
add_port_to_interface "mmur" "s_cs" "chipselect"
add_port_to_interface "mmur" "s_address" "address"
add_port_to_interface "mmur" "s_byteenable" "byteenable"
add_port_to_interface "mmur" "s_read" "read"
add_port_to_interface "mmur" "s_readdata" "readdata"
add_port_to_interface "mmur" "s_write" "write"
add_port_to_interface "mmur" "s_waitrequest" "waitrequest"
add_port_to_interface "mmur" "s_writedata" "writedata"

# Interface tx_dma
add_interface "tx_dma" "avalon" "master" "clock"
set_interface_property "tx_dma" "burstOnBurstBoundariesOnly" "false"
set_interface_property "tx_dma" "doStreamReads" "false"
set_interface_property "tx_dma" "linewrapBursts" "false"
set_interface_property "tx_dma" "doStreamWrites" "false"
# Ports in interface tx_dma
add_port_to_interface "tx_dma" "tx_m_address" "address"
add_port_to_interface "tx_dma" "tx_m_waitrequest" "waitrequest"
add_port_to_interface "tx_dma" "tx_m_readdata" "readdata"
add_port_to_interface "tx_dma" "tx_m_read" "read"
add_port_to_interface "tx_dma" "tx_m_byteenable" "byteenable"

# Interface rx_dma
add_interface "rx_dma" "avalon" "master" "clock"
set_interface_property "rx_dma" "burstOnBurstBoundariesOnly" "false"
set_interface_property "rx_dma" "doStreamReads" "false"
set_interface_property "rx_dma" "linewrapBursts" "false"
set_interface_property "rx_dma" "doStreamWrites" "false"
# Ports in interface rx_dma
add_port_to_interface "rx_dma" "rx_m_address" "address"
add_port_to_interface "rx_dma" "rx_m_waitrequest" "waitrequest"
add_port_to_interface "rx_dma" "rx_m_writedata" "writedata"
add_port_to_interface "rx_dma" "rx_m_write" "write"
add_port_to_interface "rx_dma" "rx_m_byteenable" "byteenable"

# Interface mmur_irq
add_interface "mmur_irq" "interrupt" "sender" "clock"
set_interface_property "mmur_irq" "associatedAddressablePoint" "mmur"
# Ports in interface mmur_irq
add_port_to_interface "mmur_irq" "irq" "irq"
